stages:
  - build
  - run

variables:
  IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

services:
  - docker:dind

before_script:
  - apk add --no-cache docker-compose
  - docker info
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"

build:
  stage: build
  image: docker:19.03.12
  script:
    - docker-compose -f docker-compose.yml build
    - docker tag axum-todo-site:latest "$IMAGE_TAG"
    - docker push "$IMAGE_TAG"
  only:
    - master

run:
  stage: run
  image: docker:19.03.12
  script:
    - docker pull "$IMAGE_TAG"
    - docker-compose -f docker-compose.yml up -d
    - sleep 10  # Wait for a short while to ensure the service has started
    - docker-compose logs  # Print the logs for verification
    - docker-compose down  # Stop the service
  only:
    - master
